Yandex Cloud
Search
Discuss with expertTry it for free
  • Customer Stories
  • Documentation
  • Blog
  • All Services
    • Cloud Interconnect
    • Cloud Backup
    • Cloud Registry
    • Yandex AI Studio
    • Compute Cloud
    • Object Storage
    • Managed Service for Kubernetes®
    • Yandex BareMetal
    • Smart Web Security
    • Security Deck
    • Managed Service for PostgreSQL
    • Managed Service for ClickHouse®
    • Monium
    • Cloud CDN
    • Network Load Balancer
    • Virtual Private Cloud
    • Cloud DNS
    • Application Load Balancer
    • Yandex Cloud Video
    • Stackland
    • Yandex Cloud Router
    • Yandex Managed Service for Trino
    • Managed Service for MySQL®
    • Managed Service for Valkey™
    • Managed Service for Apache Spark™
    • Yandex StoreDoc
    • Managed Service for OpenSearch
    • Managed Service for Apache Kafka®
    • Data Transfer
    • Yandex MPP Analytics Engine for PostgreSQL
    • Yandex Managed Service for Apache Airflow®
    • Data Processing
    • Yandex MetaData Hub
    • Managed Service for YDB
    • Managed Service for Sharded PostgreSQL
    • Managed Service for YTsaurus
    • Yandex WebSQL
    • DataLens
    • Yandex Search API
    • SpeechSense
    • SpeechKit
    • DataSphere
    • Vision OCR
    • Translate
    • Yandex Identity Hub
    • Key Management Service
    • Certificate Manager
    • Yandex Lockbox
    • Audit Trails
    • SmartCaptcha
    • Cloud Desktop
    • Yandex SIEM
    • SourceCraft Code Assistant
    • Container Registry
    • Managed Service for GitLab
    • Managed Service for Prometheus®
    • Cloud Functions
    • API Gateway
    • Yandex Cloud Postbox
    • Message Queue
    • Serverless Integrations
    • IoT Core
    • Data Streams
    • Serverless Containers
    • Cloud Notification Service
    • Yandex Query
    • Identity and Access Management
    • Yandex Cloud Console
    • Resource Manager
    • Yandex Cloud Billing
    • Yandex Cloud Quota Manager
    • Cloud Apps
  • System Status
  • Marketplace
    • Featured
    • Infrastructure & Network
    • Data Platform
    • AI for business
    • Security
    • DevOps tools
    • Serverless
    • Monitoring & Resources
  • All Solutions
    • By industry
    • By use case
    • Economics and Pricing
    • Security
    • Technical Support
    • Start testing with double trial credits
    • Cloud credits to scale your IT product
    • Gateway to Russia
    • Cloud for Startups
    • Center for Technologies and Society
    • Yandex Cloud Partner program
    • Price calculator
    • Pricing plans
  • Customer Stories
  • Documentation
  • Blog
© 2026 Direct Cursus Technology L.L.C.
Yandex Object Storage
  • Pricing policy
  • Terraform reference
    • API authentication
      • How to use the API
      • Signing requests
      • Getting started with the S3 API
        • All services and methods
          • All methods
          • CreateBucket
          • GetBucketEncryption
          • HeadBucket
          • ListObjects
          • ListBuckets
          • DeleteBucket
          • DeleteBucketEncryption
          • PutBucketEncryption
          • PutBucketVersioning
          • GetBucketVersioning
          • PutBucketLogging
          • GetBucketLogging
          • ListObjectVersions
          • PutObjectLockConfiguration
          • GetObjectLockConfiguration
          • PutBucketTagging
          • GetBucketTagging
          • DeleteBucketTagging
        • Common request headers
        • Common response headers
        • Responses
  • Monitoring metrics
  • Audit Trails events
  • Bucket logs
  • Release notes
  • FAQ

In this article:

  • listObjectsV2
  • Request
  • Response
  • listObjectsV1
  • Request
  • Response
  1. API reference
  2. AWS S3 REST
  3. REST
  4. Bucket
  5. ListObjects

Object Storage API, Amazon S3-compatible REST: ListObjects

Written by
Yandex Cloud
Improved by
poltsarstva
Updated at August 20, 2026
View in Markdown
  • listObjectsV2
    • Request
    • Response
  • listObjectsV1
    • Request
    • Response

Returns a list of bucket objects.

It does not return object contents; use the get method instead.

Output is paginated; you can get a list of up to 1,000 objects per request. If there are more objects, make multiple consecutive requests.

Note

This method has two versions:

  • listObjectsV2: Current version, which is easier to use.
  • listObjectsV1: Previous version.

Both methods are called using the same URL but with different query parameters. To call listObjectsV2, use the list-type=2 parameter.

For more information on getting started with the API and the general request format, see How to use the S3 API.

listObjectsV2listObjectsV2

RequestRequest

GET /{bucket}?list-type=2&continuation-token=ContinuationToken&delimiter=Delimiter&encoding-type=EncodingType&max-keys=MaxKeys&prefix=Prefix&start-after=StartAfter HTTP/2

Path parametersPath parameters

Parameter

Description

bucket

Bucket name

Query parametersQuery parameters

All parameters listed in the table are optional.

Parameter

Description

continuation-token

Use this parameter to get the next part of the list if all results do not fit in a single response.
To get the next part of the list, use the NextContinuationToken value from the previous response.

delimiter

Delimiter character.

If this parameter is specified, Object Storage interprets the key as the path to the file with folders separated by the delimiter character. In the response, the user will get a list of files and folders in the bucket. Files will be output in the Contents elements, and folders, in the CommonPrefixes elements.

If the request also specifies the prefix parameter, Object Storage will return a list of files and folders in the prefix folder.

encoding-type

Encoding of server responses.

Object Storage can encode responses in the format requested by the client.

The possible value is url.

max-keys

Maximum number of elements in a response.

By default, Object Storage outputs no more than 1,000 Contents and CommonPrefixes elements. Use this parameter if you need fewer than 1,000 elements in a single response.

If the selection criteria are met by more keys than can fit into the output, the response will contain <IsTruncated>true</IsTruncated>.

To get all the output elements if their number exceeds max-keys, run multiple requests to Object Storage with the continuation-token parameter, where the continuation-token of each request is equal to the value of the NextContinuationToken element in the previous response.

prefix

String to start the key from.

Object Storage selects only those keys which start with prefix.

Can be used together with delimiter. In this case, the output logic is determined by the delimiter parameter.

start-after

Key to start the listing from.

HeadingsHeadings

Use only common headers in your requests.

ResponseResponse

HeadersHeaders

Responses can only contain common headers.

Response codesResponse codes

For a list of possible responses, see Responses.

A successful response contains additional data in XML format with the schema described below.

Data schemaData schema

<?xml version="1.0" encoding="UTF-8"?>
<ListBucketResult>
   <IsTruncated>boolean</IsTruncated>
   <Contents>
      <ETag>string</ETag>
      <Key>string</Key>
      <LastModified>timestamp</LastModified>
      <Size>integer</Size>
      <StorageClass>string</StorageClass>
   </Contents>
   ...
   <Name>string</Name>
   <Prefix>string</Prefix>
   <Delimiter>string</Delimiter>
   <MaxKeys>integer</MaxKeys>
   <CommonPrefixes>
      <Prefix>string</Prefix>
   </CommonPrefixes>
   ...
   <EncodingType>string</EncodingType>
   <KeyCount>integer</KeyCount>
   <ContinuationToken>string</ContinuationToken>
   <NextContinuationToken>string</NextContinuationToken>
   <StartAfter>string</StartAfter>
</ListBucketResult>

Element

Description

ListBucketResult

Root element.

IsTruncated

This flag shows whether all results are returned in the response.

True means not all, False stands for all.

Path: /ListBucketResult/IsTruncated.

Contents

Object description.

The response contains as many Contents elements as there are keys that meet the request criteria.

Path: /ListBucketResult/Contents.

ETag

MD5 hash of the object. No metadata is included in the hash value calculation.

Path: /ListBucketResult/Contents/ETag.

Key

Object key.

Path: /ListBucketResult/Contents/Key.

LastModified

Date and time when the object was last modified.

Path: /ListBucketResult/Contents/LastModified.

Size

Object size in bytes.

Path: /ListBucketResult/Contents/Size.

StorageClass

Object storage class: STANDARD, COLD, ICE, or INTELLIGENT_TIERING.

Path: /ListBucketResult/Contents/StorageClass.

Name

Bucket name.

Path: /ListBucketResult/Name.

Prefix

Value of the prefix request parameter.

Path: /ListBucketResult/Prefix.

Delimiter

Value of the delimiter request parameter.

Path: /ListBucketResult/Delimiter.

MaxKeys

Value of the max-keys request parameter.

Path: /ListBucketResult/MaxKeys.

CommonPrefixes

Key name part identified when processing the delimiter and prefix request parameters.

Path: /ListBucketResult/CommonPrefixes.

EncodingType

Encoding used by Object Storage to provide a key in an XML response.

You will get this tag if the client provided the encoding-type parameter in the request.

Path: /ListBucketResult/EncodingType.

KeyCount

Number of keys the request returns.
The number of keys is always less than or equal to MaxKeys.

Path: /ContinuationToken/KeyCount.

ContinuationToken

Value of the continuation-token request parameter.

Path: /ContinuationToken/ContinuationToken.

NextContinuationToken

Value to substitute into the continuation-token query parameter to get the next part of the list, if the entire list does not fit into the current response.
It is returned only in case IsTruncated = true.

Path: /ListBucketResult/NextContinuationToken.

StartAfter

Value of the start-after request parameter.

Path: /ListBucketResult/StartAfter.

listObjectsV1listObjectsV1

RequestRequest

GET /{bucket}?delimiter=Delimiter&encoding-type=EncodingType&marker=Marker&max-keys=MaxKeys&prefix=Prefix HTTP/2

Path parametersPath parameters

Parameter

Description

bucket

Bucket name

Query parametersQuery parameters

All parameters listed in the table are optional.

Parameter

Description

delimiter

Delimiter character.

If this parameter is specified, Object Storage interprets the key as the path to the file with folders separated by the delimiter character. In the response, the user will get a list of files and folders in the bucket. Files will be output in the Contents elements, and folders, in the CommonPrefixes elements.

If the request also specifies the prefix parameter, Object Storage will return a list of files and folders in the prefix folder.

encoding-type

Encoding of server responses.

Object Storage can encode responses in the format requested by the client.

The possible value is url.

marker

Key to start the output from.

In the output, Object Storage will leave the keys starting from the one that follows marker.

max-keys

Maximum number of elements in a response.

By default, Object Storage outputs no more than 1,000 Contents and CommonPrefixes elements. Use this parameter if you need fewer than 1,000 elements in a single response.

If the selection criteria are met by more keys than can fit into the output, the response will contain <IsTruncated>true</IsTruncated>.

To get all the output elements if their number exceeds max-keys, run multiple requests to Object Storage with the marker parameter, where the marker of each request is equal to the value of the NextMarker element in the previous response.

prefix

String to start the key from.

Object Storage selects only those keys which start with prefix.

Can be used together with delimiter. In this case, the output logic is determined by the delimiter parameter.

HeadingsHeadings

Use only common headers in your requests.

ResponseResponse

HeadersHeaders

Responses can only contain common headers.

Response codesResponse codes

For a list of possible responses, see Responses.

A successful response contains additional data in XML format with the schema described below.

Data schemaData schema

<?xml version="1.0" encoding="UTF-8"?>
<ListBucketResult>
   <IsTruncated>boolean</IsTruncated>
   <Marker>string</Marker>
   <NextMarker>string</NextMarker>
   <Contents>
      <ETag>string</ETag>
      <Key>string</Key>
      <LastModified>timestamp</LastModified>
      <Size>integer</Size>
      <StorageClass>string</StorageClass>
   </Contents>
   ...
   <Name>string</Name>
   <Prefix>string</Prefix>
   <Delimiter>string</Delimiter>
   <MaxKeys>integer</MaxKeys>
   <CommonPrefixes>
      <Prefix>string</Prefix>
   </CommonPrefixes>
   ...
   <EncodingType>string</EncodingType>
</ListBucketResult>

Element

Description

ListBucketResult

Root element.

IsTruncated

This flag shows whether all results are returned in the response.

True means not all, False stands for all.

Path: /ListBucketResult/IsTruncated.

Marker

Value of the marker request parameter.

Path: /ListBucketResult/Marker.

NextMarker

Value to substitute into the marker query parameter to get the next part of the list, if the entire list does not fit into the current response.

Path: /ListBucketResult/NextMarker.

Contents

Object description.

The response contains as many Contents elements as there are keys that meet the request criteria.

Path: /ListBucketResult/Contents.

ETag

MD5 hash of the object. No metadata is included in the hash value calculation.

Path: /ListBucketResult/Contents/ETag.

Key

Object key.

Path: /ListBucketResult/Contents/Key.

LastModified

Date and time when the object was last modified.

Path: /ListBucketResult/Contents/LastModified.

Size

Object size in bytes.

Path: /ListBucketResult/Contents/Size.

StorageClass

Object storage class: STANDARD, COLD, ICE, or INTELLIGENT_TIERING.

Path: /ListBucketResult/Contents/StorageClass.

Name

Bucket name.

Path: /ListBucketResult/Name.

Prefix

Value of the prefix request parameter.

Path: /ListBucketResult/Prefix.

Delimiter

Value of the delimiter request parameter.

Path: /ListBucketResult/Delimiter.

MaxKeys

Value of the max-keys request parameter.

Path: /ListBucketResult/MaxKeys.

CommonPrefixes

Key name part identified when processing the delimiter and prefix request parameters.

Path: /ListBucketResult/CommonPrefixes.

EncodingType

Encoding used by Object Storage to provide a key in an XML response.

You will get this tag if the client provided the encoding-type parameter in the request.

Path: /ListBucketResult/EncodingType.

Related articlesRelated articles

  • Bucket in Object Storage

  • Get a list of bucket objects

Useful linksUseful links

  • Getting started with the AWS S3 API in Yandex Object Storage

  • Debugging requests using the AWS CLI

  • Example of sending a signed request using curl

  • Code example for generating a signature

Was the article helpful?

Previous
HeadBucket
Next
ListBuckets
© 2026 Direct Cursus Technology L.L.C.